﻿Imports System.Data.OleDb
Imports MQRCommon

Public Class frmChartingOpts
    Private modname As String = "frmChartingOpts"
    Private filterString As String = "(All)"
    Private rowPos As Integer
    Private firstTime As Boolean = True

    Public cm As New ContextMenu
    Friend WithEvents mnuInsert As MenuItem
    Friend WithEvents mnuInsertAft As MenuItem
    Friend WithEvents mnuDelete As MenuItem

    Friend CategoryRow As Options.CategoriesRow

    '-- Grid Column Reference Numbers
    Private grdNameCol As Integer = 0
    Private grdValueCol As Integer = 1
    Private grdColorCol As Integer = 2
    Private grdRGBCol As Integer = 3



    Private currentColumn As Integer
    Private Const cGlobalUser As String = "*GLOBAL*"
    Private Sub mnuInsert_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuInsert.Click
        Dim cpCT As FarPoint.Win.Spread.CellType.ColorPickerCellType = New FarPoint.Win.Spread.CellType.ColorPickerCellType
        cpCT.AllowFullOpen = True
        cpCT.DropDown = False
        cpCT.AnyColor = True
        cpCT.FullOpen = False
        cpCT.UnknownTextStyle = FarPoint.Win.Spread.CellType.UnknownTextStyle.Name
        cpCT.Style = FarPoint.Win.Spread.CellType.ColorPickerStyle.BoxedWithText
        Dim containsNum As Boolean

        Dim cr As FarPoint.Win.Spread.Model.CellRange = fpsMulti.ActiveSheet.GetSelection(0)
        Try
            fpsMulti.ActiveSheet.AddRows(cr.Row, cr.RowCount)
            fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).CellType = cpCT
            fpsMulti.ActiveSheet.Cells(cr.Row, 2).Value = "Black"
            containsNum = isNumeric(fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value)
            Select Case containsNum
                Case True
                    fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value = System.Drawing.ColorTranslator.FromHtml("#" & fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value)
                    fpsMulti.ActiveSheet.Cells(cr.Row, 3).Value = cnvtColorNumeric(fpsMulti.ActiveSheet.Cells(cr.Row, 2).Text.ToString)
                Case False
                    'fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value = System.Drawing.ColorTranslator.FromHtml(fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value)
                    fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value = System.Drawing.ColorTranslator.FromHtml(fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value)
                    fpsMulti.ActiveSheet.Cells(cr.Row, 3).Value = cnvtColorString(fpsMulti.ActiveSheet.Cells(cr.Row, 2).Text.ToString)
            End Select
            If filterString <> "(All)" Then
                fpsMulti.ActiveSheet.Cells(cr.Row, 0).Value = filterString

            End If
        Catch ex As Exception
            fpsMulti.ActiveSheet.AddSelection(rowPos, 0, 1, 3)
            mnuInsert_Click(Nothing, Nothing)
        End Try
    End Sub
    Private Sub mnuInsertAft_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuInsertAft.Click
        Dim cr As FarPoint.Win.Spread.Model.CellRange = fpsMulti.ActiveSheet.GetSelection(0)
        Dim cpCT As FarPoint.Win.Spread.CellType.ColorPickerCellType = New FarPoint.Win.Spread.CellType.ColorPickerCellType
        Dim containsNum As Boolean
        cpCT.AllowFullOpen = True
        cpCT.DropDown = False
        cpCT.AnyColor = True
        cpCT.FullOpen = False
        cpCT.UnknownTextStyle = FarPoint.Win.Spread.CellType.UnknownTextStyle.Name
        cpCT.Style = FarPoint.Win.Spread.CellType.ColorPickerStyle.BoxedWithText

        Try

            If rowPos = fpsMulti.ActiveSheet.RowCount - 1 Then
                fpsMulti.ActiveSheet.AddRows(fpsMulti.ActiveSheet.RowCount, cr.RowCount)
                fpsMulti.ActiveSheet.Cells.Get(fpsMulti.ActiveSheet.RowCount, 2).CellType = cpCT
                fpsMulti.ActiveSheet.Cells(fpsMulti.ActiveSheet.RowCount, 2).Value = "Black"
            Else
                If firstTime Then
                    fpsMulti.ActiveSheet.AddRows(cr.Row + 1, cr.RowCount)
                    fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).CellType = cpCT
                    fpsMulti.ActiveSheet.Cells(cr.Row, 2).Value = "Black"
                Else
                    fpsMulti.ActiveSheet.AddRows(cr.Row, cr.RowCount)
                    fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).CellType = cpCT
                    fpsMulti.ActiveSheet.Cells(cr.Row, 2).Value = "Black"
                End If
                containsNum = isNumeric(fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value)
                Select Case containsNum
                    Case True
                        fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value = System.Drawing.ColorTranslator.FromHtml("#" & fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value)
                        fpsMulti.ActiveSheet.Cells(cr.Row, 3).Value = cnvtColorNumeric(fpsMulti.ActiveSheet.Cells(cr.Row, 2).Text.ToString)
                    Case False
                        fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value = System.Drawing.ColorTranslator.FromHtml(fpsMulti.ActiveSheet.Cells.Get(cr.Row, 2).Value)
                        fpsMulti.ActiveSheet.Cells(cr.Row, 3).Value = cnvtColorString(fpsMulti.ActiveSheet.Cells(cr.Row, 2).Text.ToString)
                End Select
            End If
            If filterString <> "(All)" Then
                If rowPos = fpsMulti.ActiveSheet.RowCount - 2 Then
                    fpsMulti.ActiveSheet.Cells(rowPos + 1, 0).Value = filterString
                Else

                    If firstTime Then
                        fpsMulti.ActiveSheet.Cells(cr.Row + 1, 0).Value = filterString
                    Else
                        fpsMulti.ActiveSheet.Cells(cr.Row, 0).Value = filterString
                    End If
                    firstTime = True
                End If

            End If

        Catch ex As Exception
            firstTime = False
            fpsMulti.ActiveSheet.AddSelection(rowPos + 1, 0, 1, 3)
            mnuInsertAft_Click(Nothing, Nothing)
        End Try
    End Sub
    Private Sub mnuDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuDelete.Click
        Dim al As New ArrayList
        Dim cr() As FarPoint.Win.Spread.Model.CellRange
        Dim row As FarPoint.Win.Spread.Model.CellRange
        cr = fpsMulti.ActiveSheet.GetSelections()
        If cr.Length = 0 Then
            fpsMulti.ActiveSheet.AddSelection(rowPos, 0, 1, 3)
            cr = fpsMulti.ActiveSheet.GetSelections()
        End If
        For i As Integer = 0 To cr.Length - 1
            row = fpsMulti.ActiveSheet.GetSelection(i)
            For j As Integer = row.Row To row.Row + row.RowCount - 1
                If Not (al.Contains(j)) Then
                    al.Add(j)
                End If
            Next
        Next
        al.Sort()
        For i As Integer = al.Count - 1 To 0 Step -1
            fpsMulti.ActiveSheet.Rows(al(i)).Remove()
        Next
    End Sub
    Private Sub frmChartingOpts_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        If e.KeyCode = Keys.Escape Then
            fpsMulti.ActiveSheet.OperationMode = FarPoint.Win.Spread.OperationMode.Normal
        End If
        If e.KeyCode = Keys.Delete Then
            Dim result As MsgBoxResult
            result = MsgBox("Are you sure you want to delete the selected rows?", vbYesNo)
            Select Case result
                Case MsgBoxResult.Yes
                    deleteRows()
                Case MsgBoxResult.No
                    Exit Sub
            End Select
        End If

    End Sub

    Private Function deleteRows() As Boolean
        Dim al As New ArrayList
        Dim cr() As FarPoint.Win.Spread.Model.CellRange
        Dim row As FarPoint.Win.Spread.Model.CellRange
        cr = fpsMulti.ActiveSheet.GetSelections
        For i As Integer = 0 To cr.Length - 1
            row = fpsMulti.ActiveSheet.GetSelection(i)
            For j As Integer = row.Row To row.Row + row.RowCount - 1
                If Not (al.Contains(j)) Then
                    al.Add(j)
                End If
            Next
        Next
        al.Sort()
        For i As Integer = al.Count - 1 To 0 Step -1
            fpsMulti.ActiveSheet.Rows(al(i)).remove()
        Next
        bDirtyFlag = True
        Return True
    End Function

    Private Sub fmrChartingOpts_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SetFormFonts(Me)

        Me.Size = New Size(frmMQROptions.splContainer.Panel2.ClientSize)

        If initColorTab() = False Then
            Exit Sub
        End If

        cm.MenuItems.Add("Insert Row Above", New System.EventHandler(AddressOf mnuInsert_Click))
        cm.MenuItems.Add("Insert Row After", New System.EventHandler(AddressOf mnuInsertAft_Click))
        cm.MenuItems.Add("Delete Row", New System.EventHandler(AddressOf mnuDelete_Click))


    End Sub
    Public Sub showform(ByRef sender As Form, ByRef inCategoryRow As Options.CategoriesRow)
        CategoryRow = inCategoryRow
        sender.ControlBox = False
        sender.FormBorderStyle = FormBorderStyle.None
        sender.ShowInTaskbar = False
        sender.TopLevel = False
        sender.Visible = True
        frmMQROptions.splContainer.Panel2.Controls.Clear()
        frmMQROptions.splContainer.Panel2.Controls.Add(sender)
    End Sub
    Private Function initColorTab() As Boolean
        Dim rtnName As String = "initializeColorTab"


        readColorGrid()
        Return True
    End Function
    Private Function initColorGrid(ByVal TheOptPropArray As OptProp()) As Boolean
        Dim rtnName As String = "initializeColorGrid"
        Dim HGridLine As New FarPoint.Win.Spread.GridLine(FarPoint.Win.Spread.GridLineType.Flat, Color.Gray)
        Dim VGridLine As New FarPoint.Win.Spread.GridLine(FarPoint.Win.Spread.GridLineType.Flat, Color.Gray)

        fpsMulti.BorderStyle = BorderStyle.FixedSingle

        'determine the number of columns required 
        '-- Set the number of columns to 5 and the number of rows to 0 so we end up with exactly the number of rows we want
        fpsMulti.ActiveSheet.ColumnCount = 4
        fpsMulti.ActiveSheet.RowCount = 0

        '-- Add grid lines
        fpsMulti.ActiveSheet.HorizontalGridLine = HGridLine
        fpsMulti.ActiveSheet.VerticalGridLine = VGridLine

        '-- Turn on autosort for first two columns
        fpsMulti.ActiveSheet.Columns(0).AllowAutoSort = True
        fpsMulti.ActiveSheet.Columns(1).AllowAutoSort = True

        '-- Turn on autofilter for first two columns
        fpsMulti.ActiveSheet.Columns(0).AllowAutoFilter = True

        'fpsMulti.EditModePermanent = True

        fpsMulti.HorizontalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded
        fpsMulti.VerticalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded

        'fpsMulti.ActiveSheet.RowHeaderVisible = False

        fpsMulti.ActiveSheet.ColumnHeader.Columns(0).Label = TheOptPropArray(0).OptProp_DisplayName
        fpsMulti.ActiveSheet.ColumnHeader.Columns(0).Resizable = True
        fpsMulti.ActiveSheet.ColumnHeader.Columns(0).Width = 180
        fpsMulti.ActiveSheet.ColumnHeader.Columns(1).Label = TheOptPropArray(1).OptProp_DisplayName
        fpsMulti.ActiveSheet.ColumnHeader.Columns(1).Resizable = True
        fpsMulti.ActiveSheet.ColumnHeader.Columns(1).Width = 150
        fpsMulti.ActiveSheet.ColumnHeader.Columns(2).Label = TheOptPropArray(2).OptProp_DisplayName
        fpsMulti.ActiveSheet.ColumnHeader.Columns(2).Resizable = True
        fpsMulti.ActiveSheet.ColumnHeader.Columns(2).Width = 100
        fpsMulti.ActiveSheet.ColumnHeader.Columns(3).Label = "(R,G,B)"
        fpsMulti.ActiveSheet.ColumnHeader.Columns(3).Resizable = True
        fpsMulti.ActiveSheet.ColumnHeader.Columns(3).Width = 80
        fpsMulti.ActiveSheet.Columns(3).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Right

        '-- Set up alternating row Colors
        'fpsMulti.ActiveSheet.AlternatingRows.Count = 2
        'fpsMulti.ActiveSheet.AlternatingRows(1).BackColor = Color.FromKnownColor(KnownColor.AntiqueWhite)

        '-- Set Sheet background color
        fpsMulti.ActiveSheet.GrayAreaBackColor = Color.FromKnownColor(KnownColor.ButtonFace)


        Return True
    End Function
    Private Function readColorGrid() As Boolean
        'DANCE01 - This function is no longer generic. Due to Code available in MQRCommon and the decision to 
        'make MQROptions colors table a non-generic table
        Dim rtnName As String = "readColorGrid"

        Dim subCategory As String = ""
        lblTitle.Text = CategoryRow.categoryDescription

        Dim strcategory As String = CategoryRow.category '"QRChart"
        Dim struser As String = cGlobalUser
        Dim strpropertyName As String = "ElementValuetoColorMap"
        Dim StrOptionsColors As String

      
        ReDim OptPropArray(2)
        Dim i As Integer
        i = 0
        OptPropArray(i).OptProp_Category = strcategory
        OptPropArray(i).OptProp_PropertyName = "PropertyValue1"
        OptPropArray(i).OptProp_UserId = struser
        OptPropArray(i).OptProp_DisplayName = "ElementName"
        OptPropArray(i).OptProp_PropertyType = "General"
        i = 1
        OptPropArray(i).OptProp_Category = strcategory
        OptPropArray(i).OptProp_PropertyName = "PropertyValue2"
        OptPropArray(i).OptProp_UserId = struser
        OptPropArray(i).OptProp_DisplayName = "ElementValue"
        OptPropArray(i).OptProp_PropertyType = "General"
        i = 2
        OptPropArray(i).OptProp_Category = strcategory
        OptPropArray(i).OptProp_PropertyName = "PropertyValue3"
        OptPropArray(i).OptProp_UserId = struser
        OptPropArray(i).OptProp_DisplayName = "Color"
        OptPropArray(i).OptProp_PropertyType = "Color"
        initColorGrid(OptPropArray)
        initElementAlias()
        StrOptionsColors = frmServerComm.svrGetOptionsEdit(strcategory, cGlobalUser, "COLORS")  'Q&R 12.7 Global user only

        Dim optcolor As Options.ColorEditable()
        optcolor = Utils.DeserializeInstance(Of Options.ColorEditable())(StrOptionsColors)
        ReDim OptColorArray(0)
        If optcolor.Length = 0 Then
            loadColorGrid(0, OptColorArray)            'show a line if no entries for that category
        End If
        Dim bfirst As Boolean = True
        For Each optioneditable In optcolor
            If optcolor.Count > 0 Then
                If bfirst = True Then
                    i = 0
                    bfirst = False
                Else
                    i = i + 1
                End If
                ReDim Preserve OptColorArray(i)
                OptColorArray(i).OptColor_Category = strcategory
                OptColorArray(i).OptColor_User = struser
                OptColorArray(i).OptColor_ElemName = optioneditable.elementName
                OptColorArray(i).OptColor_ElemValue = optioneditable.value
                OptColorArray(i).OptColor_Color = optioneditable.color
                loadColorGrid(i, OptColorArray)
                LoadAliasGrid(i)
            End If

        Next

        Return True
    End Function

    Private Function LoadAliasGrid(i As Integer) As Boolean
        Dim strOptionsAliases As String

        strOptionsAliases = frmServerComm.svrGetOptionsEditAlias(cGlobalUser, "ELEMENTALIAS")  'Q&R 12.7 Global user only

        Dim optAliases As Options.ElementAliases
        optAliases = Utils.DeserializeInstance(Of Options.ElementAliases)(strOptionsAliases)

        Dim lstalias As List(Of String)
        optAliases.TryGetValue(OptColorArray(i).OptColor_ElemName, lstalias)
        ReDim Preserve OptAliasArray(0)
        OptAliasArray(0).OptAlias_Alias = lstalias(0)
        OptAliasArray(0).OptAlias_ElemName = OptColorArray(i).OptColor_ElemName
        fpsAlias.ActiveSheet.Cells.Get(0, 0).Value = OptAliasArray(0).OptAlias_Alias
        Return True
    End Function
    Private Function SaveColorGrid(ByVal optcolorArray As OptColor(), ByVal arrayRow As Integer, ByVal rowCount As Integer)
        Dim rtnName As String = "SaveQueryGrid"

        'rows aren't fixed - like other properties 
        'reload the OptColorArray with the values from the grid.

        If IsNothing(fpsMulti.ActiveSheet.Cells.Get(rowCount, grdNameCol).Value) = False Then
            optcolorArray(arrayRow).OptColor_Category = "KeyValues"
            optcolorArray(arrayRow).OptColor_ElemName = fpsMulti.ActiveSheet.Cells.Get(rowCount, grdNameCol).Value.ToString
            optcolorArray(arrayRow).OptColor_ElemValue = fpsMulti.ActiveSheet.Cells.Get(rowCount, grdValueCol).Value.ToString
            ' optcolorArray(arrayRow).OptColor_Color = fpsMulti.ActiveSheet.Cells.Get(rowCount, grdColorCol).Value.ToString
            optcolorArray(arrayRow).OptColor_Color = fpsMulti.ActiveSheet.Cells.Get(rowCount, grdRGBCol).Value.ToString
            optcolorArray(arrayRow).OptColor_User = cGlobalUser
        Else
            'an error occurred
            MsgBox("Bug?? here")
        End If

        Return True
    End Function
    Private Function SaveAliasGrid(ByVal optAliasArray As OptAlias(), ByVal elementName As String, ByVal arrayRow As Integer, ByVal rowCount As Integer)
        Dim rtnName As String = "SaveQueryGrid"

        'rows aren't fixed - like other properties 
        'reload the OptColorArray with the values from the grid.

        If IsNothing(fpsAlias.ActiveSheet.Cells.Get(rowCount, 0).Value) = False Then
            optAliasArray(arrayRow).OptAlias_Alias = fpsAlias.ActiveSheet.Cells.Get(rowCount, 0).Value.ToString
            optAliasArray(arrayRow).OptAlias_ElemName = elementName
        Else
            'an error occurred
            MsgBox("Bug?? here")
        End If

        Return True
    End Function
    Private Function initElementAlias() As Boolean
        Dim rtnName As String = "initializeColorGrid"
        Dim HGridLine As New FarPoint.Win.Spread.GridLine(FarPoint.Win.Spread.GridLineType.Flat, Color.Gray)
        Dim VGridLine As New FarPoint.Win.Spread.GridLine(FarPoint.Win.Spread.GridLineType.Flat, Color.Gray)

        fpsAlias.Visible = True
        'determine the number of columns required 
        '-- Set the number of columns to 1 and the number of rows to 0 so we end up with exactly the number of rows we want
        fpsAlias.ActiveSheet.ColumnCount = 1
        fpsAlias.ActiveSheet.RowCount = 0

        fpsAlias.ActiveSheet.Rows.Clear()
        fpsAlias.ActiveSheet.Rows.Add(0, 1)

        fpsAlias.ActiveSheet.HorizontalGridLine = HGridLine
        fpsAlias.ActiveSheet.VerticalGridLine = VGridLine

        '-- Turn on autosort for first two columns
        fpsAlias.ActiveSheet.Columns(0).AllowAutoSort = True

        fpsAlias.HorizontalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded
        fpsAlias.VerticalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded

        'fpsMulti.ActiveSheet.RowHeaderVisible = False

        fpsAlias.ActiveSheet.ColumnHeader.Columns(0).Label = "Alias"
        fpsAlias.ActiveSheet.ColumnHeader.Columns(0).Resizable = True
        fpsAlias.ActiveSheet.ColumnHeader.Columns(0).Width = 250


        '-- Set up alternating row Colors
        fpsAlias.ActiveSheet.AlternatingRows.Count = 2
        fpsAlias.ActiveSheet.AlternatingRows(1).BackColor = Color.FromKnownColor(KnownColor.ButtonFace)

        '-- Set Sheet background color
        fpsAlias.ActiveSheet.GrayAreaBackColor = Color.FromKnownColor(KnownColor.ButtonFace)

        Return True
    End Function


    'Private Function readColorGrid() As Boolean
    'original - before use of MQRCommon
    '    Dim rtnName As String = "readColorGrid"

    '    Dim sqlStatement As String = ""
    '    Dim cmd As New OleDbCommand
    '    Dim dr As OleDbDataReader
    '    Dim subCategory As String = ""

    '    '-- Get the SubCategory Information for the Header 
    '    sqlStatement = "SELECT * FROM [Categories] where [CategoryName] = '" & frmMQROptions.lsbMenu.SelectedItem & "'"
    '    Try
    '        cmd.Connection = cn
    '        cmd.CommandText = sqlStatement
    '        If cn.State = ConnectionState.Closed Then
    '            cn.Open()
    '        End If
    '        dr = cmd.ExecuteReader
    '        If dr.HasRows = True Then
    '            While (dr.Read())
    '                subCategory = dr("Category").ToString
    '                lblTitle.Text = dr("CategoryDescription")
    '            End While
    '        End If
    '    Catch ode As OleDbException
    '        SQLExceptionManager(ode, modname, rtnName, cmd, "Connection String: " & cn.ConnectionString)
    '        cn.Close()
    '        Return False
    '    Catch ex As Exception
    '        SQLExceptionManager(ex, modname, rtnName, cmd, "Connection String: " & cn.ConnectionString)
    '        cn.Close()
    '        Return False
    '    Finally
    '        cn.Close()
    '    End Try
    '    '-- End

    '    sqlStatement = "SELECT * FROM [PropertyDef] order by [Category], [PropertyName], [ValueNum]"
    '    Dim sqlStatement1 As String = ""

    '    Dim i As Integer = 0

    '    'Dim cmd As New OleDbCommand
    '    'Dim dr As OleDbDataReader

    '    cmd.Connection = cn
    '    cmd.CommandText = sqlStatement
    '    If cn.State = ConnectionState.Closed Then
    '        cn.Open()
    '    End If
    '    'Dim currentDomain As String = Environment.UserDomainName
    '    'Dim currentUser As String = Environment.UserName
    '    'Dim userDomain As String = currentDomain & "\" & currentUser

    '    Dim dt As New DataTable("Properties")
    '    Try
    '        dr = cmd.ExecuteReader
    '        If dr.HasRows = True Then

    '            dt.Load(dr)

    '        End If
    '    Catch ex As Exception
    '        SQLExceptionManager(ex, modname, rtnName, cmd, "Connection String: " & cn.ConnectionString)
    '        dr.Close()
    '        Return False
    '    Finally
    '        dr.Close()
    '    End Try

    '    Dim cnt As Integer
    '    Dim rowcount As Integer = 0
    '    'Dim OptColArray As OptCol()
    '    ReDim OptColArray(0)

    '    If dt.Rows.Count <> 0 Then
    '        For Each objDataRow In dt.Rows
    '            'Dim sqlCount As String = "SELECT COUNT(*) As [PropertyCnt] FROM [PropertyDef] where [PropertyName]='" & objDataRow.item("PropertyName") & "'"
    '            Dim sqlCount As String = "SELECT COUNT(*) FROM [PropertyDef] where [PropertyName]='" & objDataRow.item("PropertyName") & "'"
    '            cmd.CommandText = sqlCount
    '            Try
    '                cnt = cmd.ExecuteScalar
    '                'cnt = cmd.ExecuteNonQuery
    '            Catch
    '            End Try
    '            If cnt <= 1 Then    'cnt = 1 means this is a Single Val item item
    '                Continue For
    '            End If
    '            OptColArray(i).OptCol_Category = objDataRow.item("Category")
    '            OptColArray(i).OptCol_PropertyName = objDataRow.item("PropertyName")
    '            OptColArray(i).OptCol_ValueNum = objDataRow.item("ValueNum")
    '            OptColArray(i).OptCol_PropertyType = objDataRow.item("PropertyType")
    '            If IsDBNull(objDataRow.item("DisplayName")) = False Then
    '                OptColArray(i).OptCol_DisplayName = objDataRow.item("DisplayName")
    '            End If
    '            If IsDBNull(objDataRow.item("EditType")) = False Then
    '                OptColArray(i).OptCol_EditType = objDataRow.item("EditType")
    '            End If
    '            i = i + 1
    '            ReDim Preserve OptColArray(i)
    '        Next
    '        'Dim x As Integer
    '        'For x = 0 To OptColArray.Count - 1
    '        initColorGrid(OptColArray)
    '        sqlStatement1 = "SELECT * FROM [MultiVal] WHERE [Category] = '" & OptColArray(0).OptCol_Category & _
    '                       "' and [PropertyName] = '" & OptColArray(0).OptCol_PropertyName & "' and [User] = '*GLOBAL*'" & _
    '                       " ORDER BY [PropertyValue1], [PropertyValue2]"

    '        cmd.CommandText = sqlStatement1
    '        Try
    '            rowcount = 0
    '            dr = cmd.ExecuteReader
    '            If dr.HasRows = True Then
    '                While (dr.Read())
    '                    loadColorGrid(OptColArray, rowcount, dr)
    '                    rowcount += 1
    '                End While
    '            Else
    '            End If
    '        Catch ex As Exception
    '            SQLExceptionManager(ex, modname, rtnName, cmd, "Connection String: " & cn.ConnectionString)
    '            dr.Close()
    '            Return False
    '        Finally
    '            dr.Close()
    '        End Try
    '        'i += 1
    '        'Next
    '        'loadEmptyRow(OptColArray, rowcount)
    '    End If

    '    Return True

    Private Function loadColorGrid(ByVal rowcount As Integer, ByVal optcolorArray As OptColor())
        'Private Function loadColorGrid(ByVal optPropArray As OptProp(), ByVal rowcount As Integer, ByVal optcolorArray As OptColor())
        'DANCE01 - This function is no longer generic. Due to Code available in MQRCommon and the decision to 
        'make MQROptions colors table a non-generic table
        Dim rtnName As String = "LoadColorGrid"

        '-- Read only Text Cell type definition
        Dim txtCT As FarPoint.Win.Spread.CellType.TextCellType = New FarPoint.Win.Spread.CellType.TextCellType
        txtCT.ReadOnly = True

        '-- Coler Picker cell type opens a a full dialog box and allows any color to be chosen.  Fills the entire cell
        '-- with the chosen color.
        Dim cpCT As FarPoint.Win.Spread.CellType.ColorPickerCellType = New FarPoint.Win.Spread.CellType.ColorPickerCellType
        cpCT.AllowFullOpen = True
        cpCT.DropDown = False
        cpCT.AnyColor = True
        cpCT.FullOpen = False
        cpCT.UnknownTextStyle = FarPoint.Win.Spread.CellType.UnknownTextStyle.Name
        cpCT.Style = FarPoint.Win.Spread.CellType.ColorPickerStyle.BoxedWithText

        '-- Add a blank row at the bottom of the grid so you can add the new data each time
        fpsMulti.ActiveSheet.Rows.Add(rowcount, 1)

        Dim x As Integer
        Dim colValuename As String
        For x = 0 To fpsMulti.ActiveSheet.ColumnCount - 2
            colValuename = "PropertyValue" & (x + 1).ToString
            Select Case OptPropArray(x).OptProp_DisplayName.ToUpper
                Case "ElementName".ToUpper
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, x).CellType = txtCT
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = optcolorArray(rowcount).OptColor_ElemName ' data value from the table
                Case "ElementValue".ToUpper
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, x).CellType = txtCT
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = optcolorArray(rowcount).OptColor_ElemValue ' data value from the table
                Case "Color".ToUpper
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, x).CellType = cpCT
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = optcolorArray(rowcount).OptColor_Color ' data value from the table
                    Dim containsNum As Boolean
                    Dim strColor As String = optcolorArray(rowcount).OptColor_Color


                    Dim colorobj As New Color

                    Dim sysDrColor As New System.Drawing.Color
           
                    ' sysdrcolor = System.Drawing.Color.FromName("purple")
                    'containsNum = isNumeric(strColor)
                    Dim arrRGB() As String

                    arrRGB = Split(strColor, ",")
                    sysDrColor = Color.FromArgb(CInt(arrRGB(0)), CInt(arrRGB(1)), CInt(arrRGB(2)))

                   
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, grdColorCol).Value = System.Drawing.ColorTranslator.FromHtml(strColor)
                    fpsMulti.ActiveSheet.Cells.Get(rowcount, grdRGBCol).Value = strColor

                    'Select Case containsNum
                    '    Case True
                    '        fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = System.Drawing.ColorTranslator.FromHtml("#" & strColor)
                    '        fpsMulti.ActiveSheet.Cells(rowcount, 3).Value = cnvtColorNumeric(fpsMulti.ActiveSheet.Cells(rowcount, 2).Text.ToString)
                    '    Case False
                    '        Try
                    '            sysDrColor = System.Drawing.Color.FromName(strColor)
                    '        Catch ex As Exception
                    '            fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = System.Drawing.ColorTranslator.FromHtml(strColor)
                    '            fpsMulti.ActiveSheet.Cells(rowcount, 3).Value = cnvtColorString(fpsMulti.ActiveSheet.Cells(rowcount, 2).Text.ToString)
                    '        End Try
                    '        fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = System.Drawing.ColorTranslator.FromHtml(strColor)
                    '        fpsMulti.ActiveSheet.Cells(rowcount, 3).Value = cnvtColorString(fpsMulti.ActiveSheet.Cells(rowcount, 2).Text.ToString)
                    'End Select
            End Select
        Next

        fpsAlias.ActiveSheet.Rows.Clear()
        fpsAlias.ActiveSheet.Rows.Add(0, 1)
        fpsAlias.ActiveSheet.ColumnHeader.Columns(0).Label = "Aliases for " & fpsMulti.ActiveSheet.Cells(0, 0).Value

        Return True
    End Function

    Private Function colorformat(ByRef theColor As Color) As Boolean
        If theColor.IsNamedColor Then
            Return True
        Else
            Return (False)
        End If

    End Function
    'Private Function colortoargb(ByRef thecolor As Color) As String
    '    Return Color.ToString
    '    Dim colorrgb As Integer

    '    Int(colorrgb = thecolor.)

    'End Function

    'Private Function loadColorGrid(ByVal optcolarray As OptCol(), ByVal rowcount As Integer, ByVal dr As OleDbDataReader)
    'original - before use of MQRCommon
    '    Dim rtnName As String = "LoadColorGrid"

    '    '-- Read only Text Cell type definition
    '    Dim txtCT As FarPoint.Win.Spread.CellType.TextCellType = New FarPoint.Win.Spread.CellType.TextCellType
    '    txtCT.ReadOnly = True

    '    '-- Coler Picker cell type opens a a full dialog box and allows any color to be chosen.  Fills the entire cell
    '    '-- with the chosen color.
    '    Dim cpCT As FarPoint.Win.Spread.CellType.ColorPickerCellType = New FarPoint.Win.Spread.CellType.ColorPickerCellType
    '    cpCT.AllowFullOpen = True
    '    cpCT.DropDown = False
    '    cpCT.AnyColor = True
    '    cpCT.FullOpen = False
    '    cpCT.Style = FarPoint.Win.Spread.CellType.ColorPickerStyle.Boxed

    '    '-- Add a blank row at the bottom of the grid so you can add the new data each time
    '    fpsMulti.ActiveSheet.Rows.Add(rowcount, 1)

    '    'If PropDispName <> "" Then
    '    '    propName = PropDispName
    '    'End If
    '    Dim x As Integer
    '    Dim colValuename As String
    '    For x = 0 To fpsMulti.ActiveSheet.ColumnCount - 1
    '        colValuename = "PropertyValue" & (x + 1).ToString
    '        Select Case optcolarray(x).OptCol_PropertyType
    '            Case "General"
    '                fpsMulti.ActiveSheet.Cells.Get(rowcount, x).CellType = txtCT
    '                fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = dr.Item(colValuename) ' data value from the table
    '            Case "Color"
    '                fpsMulti.ActiveSheet.Cells.Get(rowcount, x).CellType = cpCT
    '                'FpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = dr.Item(colValuename) ' data value from the table
    '                Dim containsNum As Boolean
    '                containsNum = isNumeric(dr.Item(colValuename))
    '                Select Case containsNum
    '                    Case True
    '                        fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = System.Drawing.ColorTranslator.FromHtml("#" & dr.Item(colValuename))
    '                    Case False
    '                        fpsMulti.ActiveSheet.Cells.Get(rowcount, x).Value = System.Drawing.ColorTranslator.FromHtml(dr.Item(colValuename))
    '                End Select
    '        End Select
    '    Next

    '    Return True
    'End Function

    Private Function loadEmptyRow(ByVal optcolarray As OptColor(), ByVal rowCount As Integer) As Boolean
        'DANCE01 - This function is no longer generic. Due to Code available in MQRCommon and the decision to 
        'make MQROptions colors table a non-generic table
        '-- Read only Text Cell type definition
        Dim genCT As FarPoint.Win.Spread.CellType.GeneralCellType = New FarPoint.Win.Spread.CellType.GeneralCellType
        'txtCT.ReadOnly = True

        '-- Coler Picker cell type opens a a full dialog box and allows any color to be chosen.  Fills the entire cell
        '-- with the chosen color.
        Dim cpCT As FarPoint.Win.Spread.CellType.ColorPickerCellType = New FarPoint.Win.Spread.CellType.ColorPickerCellType
        cpCT.AllowFullOpen = True
        cpCT.DropDown = False
        cpCT.AnyColor = True
        cpCT.FullOpen = False
        cpCT.Style = FarPoint.Win.Spread.CellType.ColorPickerStyle.BoxedWithText

        '-- Add a blank row at the bottom of the grid so you can add the new data each time
        fpsMulti.ActiveSheet.Rows.Add(rowCount, 1)

        'If PropDispName <> "" Then
        '    propName = PropDispName
        'End If
        Dim x As Integer
        Dim colValuename As String
        For x = 0 To fpsMulti.ActiveSheet.ColumnCount - 1
            colValuename = "PropertyValue" & (x + 1).ToString
            Select Case OptPropArray(x).OptProp_DisplayName.ToUpper
                Case "ElementName".ToUpper
                    fpsMulti.ActiveSheet.Cells.Get(rowCount, x).CellType = genCT
                Case "ElementValue".ToUpper
                    fpsMulti.ActiveSheet.Cells.Get(rowCount, x).CellType = genCT
                Case "Color".ToUpper
                    fpsMulti.ActiveSheet.Cells.Get(rowCount, x).CellType = cpCT
            End Select
        Next

        Return True
    End Function

    'Private Function loadEmptyRow(ByVal optcolarray As OptColor(), ByVal rowCount As Integer) As Boolean
    'original - before use of MQRCommon
    '    '-- Read only Text Cell type definition
    '    Dim genCT As FarPoint.Win.Spread.CellType.GeneralCellType = New FarPoint.Win.Spread.CellType.GeneralCellType
    '    'txtCT.ReadOnly = True

    '    '-- Coler Picker cell type opens a a full dialog box and allows any color to be chosen.  Fills the entire cell
    '    '-- with the chosen color.
    '    Dim cpCT As FarPoint.Win.Spread.CellType.ColorPickerCellType = New FarPoint.Win.Spread.CellType.ColorPickerCellType
    '    cpCT.AllowFullOpen = True
    '    cpCT.DropDown = False
    '    cpCT.AnyColor = True
    '    cpCT.FullOpen = False
    '    cpCT.Style = FarPoint.Win.Spread.CellType.ColorPickerStyle.BoxedWithText

    '    '-- Add a blank row at the bottom of the grid so you can add the new data each time
    '    fpsMulti.ActiveSheet.Rows.Add(rowCount, 1)

    '    'If PropDispName <> "" Then
    '    '    propName = PropDispName
    '    'End If
    '    Dim x As Integer
    '    Dim colValuename As String
    '    For x = 0 To fpsMulti.ActiveSheet.ColumnCount - 1
    '        colValuename = "PropertyValue" & (x + 1).ToString
    '        Select Case OptPropArray(x).OptProp_PropertyType
    '            Case "General"
    '                fpsMulti.ActiveSheet.Cells.Get(rowCount, x).CellType = genCT
    '            Case "Color"
    '                fpsMulti.ActiveSheet.Cells.Get(rowCount, x).CellType = cpCT
    '        End Select
    '    Next

    '    Return True
    'End Function
    Private Function isNumeric(ByVal input As String) As Boolean
        If input Is Nothing Then
            input = ""
        End If
        For Each c As Char In input
            If Char.IsNumber(c) Then
                Return True
            End If
        Next
        Return False
    End Function

    Private Sub cmdFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdFind.Click
        fpsMulti.SearchWithDialog(0, "", False, False, False, False, 0, 0)
    End Sub

    Private Sub fpsMulti_AutoFilteredColumn(sender As Object, e As FarPoint.Win.Spread.AutoFilteredColumnEventArgs) Handles fpsMulti.AutoFilteredColumn
        filterString = e.FilterString
        If e.FilterString <> "(All)" Then
            fpsAlias.Visible = True
            fpsAlias.ActiveSheet.Rows.Clear()
            fpsAlias.ActiveSheet.Rows.Add(0, 1)
            fpsAlias.ActiveSheet.ColumnHeader.Columns(0).Label = "Aliases for " & e.FilterString
            'fpsAlias.ActiveSheet.Cells(0, 0).Value = e.FilterString
            'Else
            '    fpsAlias.Visible = False
        End If
    End Sub

    Private Sub fpsMulti_CellClick(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.CellClickEventArgs) Handles fpsMulti.CellClick
        If e.RowHeader = True Then
            fpsMulti.ContextMenu = cm
            fpsMulti.ActiveSheet.OperationMode = FarPoint.Win.Spread.OperationMode.ExtendedSelect

        Else
            fpsMulti.ContextMenu = Nothing
            fpsMulti.ActiveSheet.OperationMode = FarPoint.Win.Spread.OperationMode.Normal
        End If
        rowPos = e.Row
        If e.Column = 0 Then
            fpsAlias.Visible = True
            fpsAlias.ActiveSheet.ColumnHeader.Columns(0).Label = "Aliases for " & fpsMulti.ActiveSheet.Cells(e.Row, e.Column).Value
        End If
    End Sub

    Private Sub fpsMulti_EditChange(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.EditorNotifyEventArgs) Handles fpsMulti.EditChange
        bDirtyFlag = True
        Dim containsNum As Boolean
        If e.Column = 2 Then
            Dim strColor As String = fpsMulti.ActiveSheet.Cells.Get(e.Row, 2).Text.ToString
            containsNum = isNumeric(strColor)
            Select Case containsNum
                Case True
                    fpsMulti.ActiveSheet.Cells.Get(e.Row, 2).Value = System.Drawing.ColorTranslator.FromHtml("#" & fpsMulti.ActiveSheet.Cells.Get(e.Row, 2).Text.ToString)
                    Dim col As String = fpsMulti.ActiveSheet.Cells(e.Row, 2).Text.ToString
                    Dim b As New SolidBrush(ColorTranslator.FromHtml("#" & col))
                    fpsMulti.ActiveSheet.Cells(e.Row, 3).Value = b.Color.R & "," & b.Color.G & "," & b.Color.B
                    'fpsMulti.ActiveSheet.Cells(cr.Row, 3).CellType = txtCT
                Case False
                    fpsMulti.ActiveSheet.Cells.Get(e.Row, 2).Value = System.Drawing.ColorTranslator.FromHtml(fpsMulti.ActiveSheet.Cells.Get(e.Row, 2).Text.ToString)
                    Dim col As String = fpsMulti.ActiveSheet.Cells(e.Row, 2).Text.ToString
                    Dim b As New SolidBrush(ColorTranslator.FromHtml(col))
                    fpsMulti.ActiveSheet.Cells(e.Row, 3).Value = b.Color.R & "," & b.Color.G & "," & b.Color.B
                    'fpsMulti.ActiveSheet.Cells(cr.Row, 3).CellType = txtCT
            End Select
        End If
        If e.Column = 3 Then
            fpsMulti.ActiveSheet.Cells(e.Row, 2).Value = Color.FromArgb("(" & fpsMulti.ActiveSheet.Cells(e.Row, 3).Text.ToString & ")")
        End If
    End Sub


    Private Sub cmdApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdApply.Click
        Dim domainUser As String = Environment.UserDomainName & "\" & Environment.UserName.ToUpper
        Dim elementname As String
        'Clear the OptColorArray and reload with values from the grid 
        ReDim OptColorArray(fpsMulti.ActiveSheet.RowCount - 1)

        For i = 0 To fpsMulti.ActiveSheet.RowCount - 1
            SaveColorGrid(OptColorArray, i, i)
        Next

        Update_OptionsColors(cGlobalUser)
        'Update_OptionsSingle(domainUser)
        'For i As Integer = 0 To fpsProperties.ActiveSheet.RowCount - 1
        '    Debug.Print("Data Values " & fpsProperties.ActiveSheet.Cells(i, 0).Value & Chr(10) & fpsProperties.ActiveSheet.Cells(i, 1).Value)
        'Next
        ReDim OptAliasArray(fpsAlias.ActiveSheet.RowCount - 1)
        Dim ActiveRow As Integer
        activerow = fpsMulti.ActiveSheet.ActiveRowIndex
        elementname = fpsMulti.ActiveSheet.Cells.Get(activerow, grdNameCol).Value.ToString
        For i = 0 To fpsAlias.ActiveSheet.RowCount - 1
            SaveAliasGrid(OptAliasArray, elementname, i, i)
        Next

        Update_Alias(cGlobalUser)


        bDirtyFlag = False
    End Sub
    Private Sub Update_OptionsColors(theuser As String)
        '  PrintDebugInfo("Singleval")

        Dim thesql As String
        Dim cmdRead As New OleDbCommand
        Dim cmdInsert As New OleDbCommand
        Dim cmdUpdate As New OleDbCommand
        Dim CAvalue As String
        Dim SiteValue As String
        Dim UserValue As String
        Dim CompareValue As String
        Dim NewValue As String
        Dim dr As OleDbDataReader
        Dim colorvals(OptColorArray.Count - 1) As Options.ColorMapRow



        For i = 0 To OptColorArray.Count - 1
            colorvals(i) = New Options.ColorMapRow
            colorvals(i).category = OptColorArray(i).OptColor_Category
            colorvals(i).elementName = OptColorArray(i).OptColor_ElemName
            colorvals(i).dataValue = OptColorArray(i).OptColor_ElemValue
            colorvals(i).color = OptColorArray(i).OptColor_Color
            colorvals(i).user = OptColorArray(i).OptColor_User
            'If theuser = "*GLOBAL*" Then
            '    If OptPropArray(i).OptProp_SiteValue <> OptPropArray(i).OptProp_CADefaultValue Then
            '        colorvals(i).propertyValue1 = OptPropArray(i).OptProp_SiteValue
            '    Else
            '        colorvals(i).propertyValue1 = Nothing 'vbNullString
            '    End If
            'Else
            '    If OptPropArray(i).OptProp_SiteValue <> Nothing Then 'vbNull Then
            '        If OptPropArray(i).OptProp_UserValue <> OptPropArray(i).OptProp_SiteValue Then
            '            colorvals(i).propertyValue1 = OptPropArray(i).OptProp_UserValue
            '        End If
            '    Else
            '        If OptPropArray(i).OptProp_UserValue <> OptPropArray(i).OptProp_CADefaultValue Then
            '            colorvals(i).propertyValue1 = OptPropArray(i).OptProp_UserValue
            '        End If
            '    End If
            'End If

        Next
        'call the server to update
        Dim updOK As Boolean
        updOK = frmServerComm.svrUpdateOptions(colorvals)

        'For i = 0 To OptPropArray.Count - 1


        '    '-- Actually Read the information to load the grid based on the Subcategory
        '    thesql = "SELECT * FROM [SingleVal] WHERE [category] = '" & OptPropArray(i).OptProp_Category & _
        '                       "' " & " and " & " [User] = '" & theuser & "'" & " and [PropertyName] = '" & OptPropArray(i).OptProp_PropertyName & "'"

        '    cmdRead.Connection = cn
        '    cmdInsert.Connection = cn
        '    cmdUpdate.Connection = cn


        '    cmdRead.CommandText = thesql
        '    If cn.State = ConnectionState.Closed Then
        '        cn.Open()
        '    End If
        '    CAvalue = fpsProperties.ActiveSheet.Cells(i, 1).Value
        '    SiteValue = fpsProperties.ActiveSheet.Cells(i, 2).Value
        '    UserValue = fpsProperties.ActiveSheet.Cells(i, 3).Value

        '    Select Case theuser
        '        Case "*GLOBAL*"
        '            CompareValue = CAvalue
        '            NewValue = SiteValue
        '        Case Else
        '            CompareValue = SiteValue
        '            NewValue = UserValue
        '    End Select


        '    Try
        '        dr = cmdRead.ExecuteReader
        '        If dr.HasRows = True Then
        '            If NewValue <> CompareValue Then
        '                Update_SingleVal(i, theuser, NewValue, cn)
        '            Else
        '                Delete_SingleVal(i, theuser, cn)
        '            End If
        '        Else
        '            If NewValue <> Nothing Then
        '                If NewValue <> CompareValue Then
        '                    Insert_Singleval(i, theuser, NewValue, cn)
        '                End If
        '            End If
        '        End If
        '        dr.Close()
        '    Catch ex As Exception

        '    End Try
        'Next


    End Sub

    Private Function Update_Alias(ByRef theuser As String) As Boolean
        'Dim Aliasvals(OptAliasArray.Count - 1) As Options.ElementAliasRow
        Dim Aliasvals As New List(Of String)
        Dim strAliasVals As String
        Dim elementname As String = OptAliasArray(0).OptAlias_ElemName

        'Dim strAliasvals() As String
        'ReDim strAliasvals(OptAliasArray.Count - 1)
        'strAliasvals(0) = "TEST"
        Dim updOK As Boolean
        For i = 0 To OptAliasArray.Count - 1
            Aliasvals.Add(OptAliasArray(i).OptAlias_Alias)
            'Aliasvals(i) = New Options.ElementAliasRow
            'Aliasvals(i).alias = OptAliasArray(i).OptAlias_Alias
            'Aliasvals(i).elementName = OptAliasArray(i).OptAlias_ElemName
        Next

        strAliasVals = Utils.SerializeInstance(Aliasvals)
        'Utils.SerializeInstance(strAliasvals)


        updOK = frmServerComm.svrUpdateOptions(Aliasvals, strAliasVals, elementname)
        Return updOK
    End Function

    Private Sub fpsMulti_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles fpsMulti.KeyDown
        If e.KeyCode = Keys.Delete Then
            bDirtyFlag = True
        End If

    End Sub
    Private Function cnvtColorNumeric(ByVal myColor As String) As String

        Dim col As String = myColor
        Dim b As New SolidBrush(ColorTranslator.FromHtml("#" & col))
        cnvtColorNumeric = b.Color.R & "," & b.Color.G & "," & b.Color.B

    End Function
    Private Function cnvtColorString(ByVal myColor As String) As String

        Dim col As String = myColor
        Dim b As New SolidBrush(ColorTranslator.FromHtml(col))
        cnvtColorString = b.Color.R & "," & b.Color.G & "," & b.Color.B

    End Function
End Class
