﻿Imports System
imports System.Collections.Generic
imports System.Linq
imports System.Text
imports System.Data.OleDb
imports System.Data.Linq
imports System.Data.Linq.Mapping
imports System.Data.SqlClient
Imports System.IO
Imports System.Object


'Namespace DotMQROPTIONS
Public Class MQROptionsDBAccess

    '/* This class represents a connection to Options database. */
    'Private Const OptdbFileName As String = "C:\MQROptions.accdb"
    Private Const optionsDBName As String = "C:\MQROptions.accdb"
    Private Const OptdbProvider As String = "provider=Microsoft.ACE.OLEDB.12.0; data source=" & optionsDBName & ";"
    Private conn As OleDbConnection

    '/* Open the database. */
    Public Sub Open()

        If File.Exists(optionsDBName) <> False Then

            MsgBox("6021E", "Utility database " + optionsDBName + " does not exist")
            ' Throw New DataAccessException(optionsDBName, e)

            Try

                conn = New OleDbConnection(OptdbProvider + optionsDBName)
                conn.Open()

            Catch e As InvalidOperationException

                '  Throw New DataAccessException(optionsDBName, e)
            End Try
        End If


    End Sub


    '/* Close the database. */
    Public Sub Close()
        'conn.Close()
    End Sub

    '/* Retrieve list of PropertyDef objects (Property Definitions) from the MQROptions database */
    Public Function GetPropertyDef() As List(Of MQROptions.PropertyDef)
        Try
            Dim dx = New DataContext(cn)  '(conn)
            Dim PropertyDefTbl As Table(Of MQROptions.PropertyDef) = dx.GetTable(Of MQROptions.PropertyDef)()
            Dim pdefrecords As IEnumerable(Of MQROptions.PropertyDef)
            pdefrecords = From Pdef In PropertyDefTbl Select Pdef 'Where Pdef.category = "MICSQRini"
            pdefrecords.ToList()
            Return pdefrecords.ToList()
            '            ret = query.ToList()

            '            //Program.LogDebug(5, 106, "GetRMWSLoadJobs DataContext Log: " + dx.Log.ToString());
            '            Debug.Print("GetRMWSLoadJobs DataContext Log: " + dx.Log.ToString())

            '            ret = ret.Where(r => r.autoRun).ToList();

            '            return ret;
            '        }
        Catch e As SqlException
            ' Throw New DataAccessException(optionsDBName, e)
        End Try
    End Function
    '/* Retrieve list of PropertyDef objects (Property Definitions) from the MQROptions database */
    Public Function GetEditList() As List(Of MQROptions.EditList)

        Try
            'Dim strlog As String
            Dim dx = New DataContext(cn)  '(conn)
            Dim EditListTbl As Table(Of MQROptions.EditList) = dx.GetTable(Of MQROptions.EditList)()
            Dim editlistrecords As IEnumerable(Of MQROptions.EditList)
            editlistrecords = From eList In EditListTbl Select eList
            ' strlog = dx.Log.ToString
            ' dx.Log.Write("test")

            Return editlistrecords.ToList()


            'Return pdefrecords.ToList()
            '            ret = query.ToList()

            '            //Program.LogDebug(5, 106, "GetRMWSLoadJobs DataContext Log: " + dx.Log.ToString());
            '            Debug.Print("GetRMWSLoadJobs DataContext Log: " + dx.Log.ToString())

            '            ret = ret.Where(r => r.autoRun).ToList();

            '            return ret;
            '        }
        Catch e As SqlException
            ' Throw New DataAccessException(optionsDBName, e)
        End Try
    End Function

    
End Class

'public class DataAccessException : Exception 
'        'public DataAccessException(string dbFileName) : base(ErrorMessage(dbFileName)) { }
'        'public DataAccessException(string dbFileName, Exception e) : base(ErrorMessage(dbFileName), e) { }

'        'public void Log() {
'        '    string msg = Message;
'        '    if (InnerException != null) msg = msg + " Exception:" + InnerException.ToString();
'        '    Program.LogPrint("6023E", msg);            
'        '}

'        'private static string ErrorMessage(string dbFileName) {
'        '    return "Access to database " + dbFileName + " failed.";
'        'End Class

'End Namespace