﻿Imports System.Net
Imports System.Data.OleDb
Imports MQRCommon
'-- Required to Manage MQRServer Service only
'-- Must add Reference System.ServiceProcess to get this to work
Imports System.ServiceProcess


Public Class frmMQROptions
    Private modname As String = "frmMQROptions"
    Private itemFormat As StringFormat

    'Public hostName As String

    Private lastSelectedItem As String = ""
    Private lastSelectedIdx As Integer = 0

    Dim cats As Options.CategoriesRow()

    Private Sub frmMQROptions_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Try
            Application.Exit()
        Catch
        End Try

    End Sub

    Private Sub frmMQROptions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim logResult As Boolean

        SetFormFonts(Me)
        'cbd test code
        'Dim propdefs As New List(Of MQROptions.PropertyDef)
        'Dim editlists As New List(Of MQROptions.EditList)
        'Dim DBPropDef As New MQROptionsDBAccess

        'openDB()
        '' propdefs = DBPropDef.GetPropertyDef()
        '' editlists = DBPropDef.GetEditList()

        'DBPropDef.Close()
        'End cbd test

        If Not initializeVariables(cnString, optionsDBName) Then
            MsgBox("MQR1000E: " & "A Fatal error occured during program initialzation." & vbCrLf & "Program exiting", MsgBoxStyle.Exclamation, "MQRAdmin Fatal Error")
        End If


        If openDB(cnString, optionsDBName) = False Then
            Exit Sub
        End If

        'logResult = frmServerComm.svrLogon(AdminUserID)
        If Not logResult Then
            statusBarMsg("MQR2300E", "Could not connect to Distributed Server.  Will continue with limited functionality.")
        End If

        ttsMessage.Width = Me.Width * 0.8
        ttsConnection.Width = Me.Width * 0.2
        ttsMessage.Text = ""

        '-- Get local host name for Server
        hostName = Dns.GetHostName()

        '-- update the status bar with the status of the server
        tmrServerStatus_Tick(Nothing, Nothing)

        If initializeForm() = False Then
            Exit Sub
        End If
        frmMQROptions_Resize(Nothing, Nothing)

    End Sub
    Public Function openDB(cnstring As String, optionsdbname As String) As Boolean
        Dim rtnName As String = "openDB"


        If System.IO.File.Exists(optionsDBName) Then
            optionsDBName = System.IO.Path.GetDirectoryName(optionsDBName) & "\" & System.IO.Path.GetFileNameWithoutExtension(optionsDBName) & ".accdb"

            Try
                'cnstring = "provider=Microsoft.ACE.OLEDB.12.0; data source=" & optionsdbname & ";"
                cn.ConnectionString = cnstring
                cn.Open()
            Catch ex As Exception
                Error_MsgBox(modname & ":" & rtnName, ex.Message & vbCrLf & "cnString: " & cnstring, "MQR1000E")
            End Try
        Else
            Error_MsgBox(modname & ":" & rtnName, optionsDBName & " does not exist.", "MQR12054E")
            Return False
        End If

        Return True

        Return True
    End Function
    Private Function initializeForm() As Boolean

        Dim rtnName As String = "readQueryGrid"
        Dim StrOptionsCategories As String
        'StrChartOptions = svrGetOptions("QRChart", "TANT-A01\DANCE01")
        StrOptionsCategories = frmServerComm.svrGetOptionsCategory()  'Q&R 12.7 Global user only


        cats = Utils.DeserializeInstance(Of Options.CategoriesRow())(StrOptionsCategories)
        For Each CategoriesRow In cats
            If CategoriesRow.displayGlobalVals = True Or
                CategoriesRow.displayUserVals = True Then
                lsbMenu.Items.Add(CategoriesRow.categoryName)
            End If
        Next
        lsbMenu.SelectedIndex = 0
        Return True
        'lsbMenu.Sorted = True


        'Dim sqlStatement As String = "SELECT DISTINCT [SubCategory] FROM [PropertyDef] ORDER BY [SubCategory]"
        'Dim sqlStatement As String = "SELECT * FROM [Categories] ORDER BY [SeqNum]"

        'Dim i As Integer = 0

        'Dim cmd As New OleDbCommand
        'Dim dr As OleDbDataReader
        'Dim dt As New DataTable("Categories")

        'cmd.Connection = cn
        'cmd.CommandText = sqlStatement

        'Try
        '    dr = cmd.ExecuteReader
        '    If dr.HasRows = True Then

        '        dt.Load(dr)

        '    End If
        'Catch ex As Exception
        '    SQLExceptionManager(ex, modname, rtnName, cmd, "Connection String: " & cn.ConnectionString)
        '    dr.Close()
        '    Return False
        'Finally
        '    dr.Close()
        'End Try

        'For Each objdatarow In dt.Rows
        '    lsbMenu.Items.Add(objdatarow.item("CategoryName"))
        'Next
        'lsbMenu.SelectedIndex = 0

        'lsbMenu.DataSource = dt
        'lsbMenu.ValueMember = ""
        'lsbMenu.DisplayMember = "SubCategory"


        Return True
    End Function
    'Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
    '    Dim rtnName As String = "OnLoad"
    '    MyBase.OnLoad(e)

    '    Me.itemFormat = New StringFormat()
    '    'Me.itemFormat.Alignment = StringAlignment.Center
    '    Me.itemFormat.LineAlignment = StringAlignment.Center
    'End Sub
    'Private Sub lsbMenu_DrawItem(ByVal sender As Object, _
    '                             ByVal e As System.Windows.Forms.DrawItemEventArgs) _
    '                             Handles lsbMenu.DrawItem
    '    Dim rtnName As String = "lsbMenu_DrawItem"

    '    e.DrawBackground()
    '    Dim myBrush As Brush = Brushes.Black
    '    e.Graphics.DrawString(Me.lsbMenu.Items(e.Index).ToString(), _
    '                          e.Font, myBrush, e.Bounds, _
    '                          Me.itemFormat)

    '    'If (e.State And DrawItemState.Selected) = DrawItemState.Selected Then
    '    '    e.Graphics.FillRectangle(Brushes.Aqua, e.Bounds)
    '    'Else
    '    '    e.Graphics.FillRectangle(Brushes.White, e.Bounds)
    '    'End If
    '    'Using b As New SolidBrush(e.ForeColor)
    '    '    e.Graphics.DrawString(lsbMenu.GetItemText(lsbMenu.Items(e.Index)), e.Font, b, e.Bounds, Me.itemFormat)
    '    'End Using
    '    'e.DrawFocusRectangle()

    'End Sub


    Private Sub lsbMenu_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lsbMenu.SelectedValueChanged
        If bDirtyFlag = True Then
            Dim result As MsgBoxResult
            result = MsgBox("Changes have been made, are you sure you want" & _
                            "to leave without applying them?", vbYesNo)
            Select Case result
                Case MsgBoxResult.Yes
                    bDirtyFlag = False
                Case MsgBoxResult.No
                    lsbMenu.SelectedItem = lastSelectedItem
            End Select
        End If
        lastSelectedIdx = lsbMenu.SelectedIndex
        Select Case lsbMenu.SelectedItem
            Case "Color Mapping"
                lastSelectedItem = "Color Mapping"
                frmINIOptions.Hide()
                If frmChartingOpts.Visible = False Then
                    frmChartingOpts.showform(frmChartingOpts, cats(lsbMenu.SelectedIndex))
                    frmChartingOpts.Size = New Size(Me.splContainer.Panel2.ClientSize)
                    frmINIOptions.Size = New Size(Me.splContainer.Panel2.ClientSize)
                End If
            Case "Server Settings"
                lastSelectedItem = "Server Setting"
                frmChartingOpts.Hide()
                If frmINIOptions.Visible = True Then
                    frmINIOptions.Close()
                End If
                frmINIOptions.showform(frmINIOptions, cats(lsbMenu.SelectedIndex))
                frmINIOptions.Size = New Size(Me.splContainer.Panel2.ClientSize)
            Case "Query Settings"
                lastSelectedItem = "Query Settings"
                frmChartingOpts.Hide()
                If frmINIOptions.Visible = True Then
                    frmINIOptions.Close()
                End If
                frmINIOptions.showform(frmINIOptions, cats(lsbMenu.SelectedIndex))
                frmINIOptions.Size = New Size(Me.splContainer.Panel2.ClientSize)
            Case "Utility Settings"
                lastSelectedItem = "Utility Settings"
                frmChartingOpts.Hide()
                If frmINIOptions.Visible = True Then
                    frmINIOptions.Close()
                End If
                frmINIOptions.showform(frmINIOptions, cats(lsbMenu.SelectedIndex))
                frmINIOptions.Size = New Size(Me.splContainer.Panel2.ClientSize)
            Case "Charting Settings"
                lastSelectedItem = "Charting Settings"
                frmChartingOpts.Hide()
                If frmINIOptions.Visible = True Then
                    frmINIOptions.Close()
                End If
                frmINIOptions.showform(frmINIOptions, cats(lsbMenu.SelectedIndex))
                frmINIOptions.Size = New Size(Me.splContainer.Panel2.ClientSize)
        End Select
    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    

    Private Sub frmMQROptions_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If frmINIOptions.Visible = True Then
            frmINIOptions.Size = New Size(Me.splContainer.Panel2.ClientSize)
        End If
        If frmChartingOpts.Visible = True Then
            frmChartingOpts.Size = New Size(Me.splContainer.Panel2.ClientSize)
        End If

        '-- set the message area
        ttsMessage.Width = Me.Width * 0.8
        ttsConnection.Width = Me.Width * 0.2

    End Sub


    Private Sub tmrMessage_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrMessage.Tick
        '-- Reset Status bar message so it doesn't stay displayed for an extended period
        '-- default timer period is 3 seconds

        If Trim(ttsMessage.Text) <> "" Then
            ttsMessage.Text = ""
        End If
        tmrMessage.Enabled = False
    End Sub

    Private Sub tmrServerStatus_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrServerStatus.Tick
        getServerStatus()
        Select Case serverUpDownStatus
            Case "Up"
                ttsConnection.Text = hostName & "  [+]"

            Case "Down"
                ttsConnection.Text = hostName & "  [-]"
        End Select
    End Sub
    Private Function getServerStatus() As Boolean
        getServerStatus = True
        Dim strName As String = "MQRServerSrvc"
        Try
            Dim msvc As New ServiceController(strName)
            With msvc
                Select Case .Status
                    Case ServiceControllerStatus.Stopped
                        serverUpDownStatus = "Down"
                    Case ServiceControllerStatus.StopPending
                        serverUpDownStatus = "Down"
                    Case ServiceControllerStatus.Paused
                        serverUpDownStatus = "Down"
                    Case ServiceControllerStatus.PausePending
                        serverUpDownStatus = "Down"
                    Case ServiceControllerStatus.ContinuePending
                        serverUpDownStatus = "Down"
                    Case Else
                        serverUpDownStatus = "Up"
                End Select
            End With
        Catch ex As Exception
            statusBarMsg("MQR1000I", "Could not obtain current Q&R Distributed Server status.")
        End Try

    End Function

    Private Sub mnuOptionsQRDistServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOptionsQRDistServer.Click
        ConnectToDS(True)
    End Sub
    Private Sub ConnectToDS(ByVal bShowScreen As Boolean)
        'ConnectToDS - Connect to a Distributed Server
        'if bShowScreen = true then the Q&R Query Connect panel is displayed; otherwise
        'you will connect to the most recently used server

        'Dim lpRect As RECT
        Dim i As Integer, iLastForm As Integer

        On Error GoTo BadUnload

 
        If bShowScreen = True Then
             frmServerComm.txtIP.Text = gcurrentIP
            frmServerComm.txtPort.Text = gcurrentPort
            frmServerComm.Show()
            bShowSvrComm = False
        Else
            Application.Exit()
        End If
        'no Set MDIFrmMQRQuery = Nothing
        Exit Sub

BadUnload:
        Error_MsgBox("frmMQROptions:ConnectToDS", "Trying to Connect to load frmSrvComm", "MQR1000E")
        Exit Sub
    End Sub
End Class
